/*
 *  ===================================================================
 *  Squares.java: Find integer values of x, y, and z where:
 *
 *                x^2 + y^2 + z^2 = 377                        (eqn 1.)
 *
 *                Also find the max and min values of (x+y+z) that also
 *                satisfy eqn 1.
 *
 *  Note: The square root of 377 is 19.41. Hence values of x, y, and z
 *  may be as large as 19, but not 20.
 *
 *  Written by: Mark Austin                               November 2009
 *  ===================================================================
 */

package basics;

import java.lang.Math;

public class DemoLoopSquares {
   public static void main ( String args[] ) {
      int iSum;
      int iSumMin = 57;
      int iSumMax = 0;

      for ( int iX = 0; iX <= 19; iX = iX + 1 )
      for ( int iY = 0; iY <= 19; iY = iY + 1 )
         for ( int iZ = 0; iZ <= 19; iZ = iZ + 1 ) {

            iSum = iX*iX + iY*iY + iZ*iZ;

            if ( iSum == 377 ) {
               System.out.printf ("(x,y,z) = (%2d,%2d,%2d): iSum = %d\n",
                                  iX, iY, iZ, iSum );

               iSumMin = Math.min( iSumMin, iX + iY + iZ );
               iSumMax = Math.max( iSumMax, iX + iY + iZ );
            }
         }

      System.out.printf ("Minumum (x+y+z) = %2d\n", iSumMin );
      System.out.printf ("Maximum (x+y+z) = %2d\n", iSumMax );

   }
}
