/*
 *  =======================================================================
 *  DemoTextInput.java: Prompt user for four floating point numbers,
 *  print each number, and then find and print the smallest/largest values.
 *
 *  Written By: Mark Austin                                  November, 2007
 *  =======================================================================
 */

package basics;

import java.lang.Math;
import java.io.*;

public class DemoTextInput {
    public static void main( String args[] ) {
        double dA, dB, dC, dD;
        String sLine;

        // Prompt user for numbers dA, dB, dC, and dD.

        System.out.println("Please enter dA, dB, dC and dD");
        System.out.print("dA: ");
        System.out.flush();
        sLine = getTextFromConsole();
        dA    = Double.valueOf(sLine).doubleValue();

        System.out.print("dB: ");
        System.out.flush();
        sLine = getTextFromConsole();
        dB    = Double.valueOf(sLine).doubleValue();

        System.out.print("dC: ");
        System.out.flush();
        sLine = getTextFromConsole();
        dC    = Double.valueOf(sLine).doubleValue();

        System.out.print("dD: ");
        System.out.flush();
        sLine = getTextFromConsole();
        dD    = Double.valueOf(sLine).doubleValue();

        // Print each of the numbers ....

        System.out.println("Input: dA = " + dA );
        System.out.println("       dB = " + dB );
        System.out.println("       dC = " + dC );
        System.out.println("       dD = " + dD );

        // Ccmpute and print largest/smallest values....

        System.out.println("Smallest value = " +
                            Math.min( Math.min( dA, dB), Math.min( dC, dD )));
        System.out.println("Largest value = " +
                            Math.max( Math.max( dA, dB), Math.max( dC, dD )));
    }

    /* 
     *  ============================================================
     *  Method getTextFromConsole(): Read line of text from keyboard
     * 
     *  Input  : None.
     *  Output : String sLine -- character string of keyboard input
     *  ============================================================
     */

    public static String getTextFromConsole() {
       String inLine = "";

       // Create buffered reader for keyboard input stream....

       BufferedReader inStream = new BufferedReader (
                                 new InputStreamReader(System.in));

       // Try to read input from keyboard ....

       try {
          inLine = inStream.readLine();
       } catch (IOException e) {
          System.out.println("IOException: " + e);
       }

       return inLine;
    }
}
